
  PROGRAM

  MAP
    INCLUDE('i64.inc')
RemoveNull PROCEDURE(String inString),String
    MODULE('winapi')
      CredReadA(*CSTRING szTargetName,LONG dwType,LONG dwFlags,*LONG lpCredential),LONG,RAW,PASCAL,Name('CredReadA')
      CredFree(LONG Buffer),RAW,PASCAL,NAME('CredFree')
      GetLastError(),LONG,PASCAL,NAME('GetLastError')
    END
  END

WindowsCredential_MAX_STRING_LENGTH            EQUATE(256)

WindowsCredential_Flags_Prompt_Now             EQUATE(1)
WindowsCredential_Flags_Username_Target        EQUATE(2)

WindowsCredential_TYPE_GENERIC                 EQUATE(1)
WindowsCredential_TYPE_DOMAIN_PASSWORD         EQUATE(2)
WindowsCredential_TYPE_DOMAIN_CERTIFICATE      EQUATE(3)
WindowsCredential_TYPE_DOMAIN_VISIBLE_PASSWORD EQUATE(4)
WindowsCredential_TYPE_GENERIC_CERTIFICATE     EQUATE(5)
WindowsCredential_TYPE_DOMAIN_EXTENDED         EQUATE(6)
WindowsCredential_TYPE_MAXIMUM                 EQUATE(7)
WindowsCredential_TYPE_MAXIMUM_EX              EQUATE(WindowsCredential_TYPE_MAXIMUM+1000)

WindowsCredential_PERSIST_SESSION              EQUATE(1)
WindowsCredential_PERSIST_LOCAL_MACHINE        EQUATE(2)
WindowsCredential_PERSIST_ENTERPRISE           EQUATE(3)

WindowsCredential_MAX_ATTRIBUTES               EQUATE(64)

Credential_AttributeA GROUP,TYPE
lpszKeyword             UNSIGNED
Flags                   UNSIGNED
ValueSize               UNSIGNED
lpbyValue               UNSIGNED
                      END

CredentialA           GROUP,TYPE
Flags                   UNSIGNED
Type                    UNSIGNED
lpszTargetName          UNSIGNED
lpszComment             UNSIGNED
LastWritten             GROUP(INT64) END
CredentialBlobSize      UNSIGNED
pCredentialBlob         UNSIGNED
Persist                 UNSIGNED
AttributeCount          UNSIGNED
pAttributes             UNSIGNED
lpszTargetAlias         UNSIGNED
lpszUserName            UNSIGNED
                      END

szTargetName          CSTRING(WindowsCredential_MAX_STRING_LENGTH)
dwType                LONG
dwFlags               LONG
Credential              &CredentialA
Credential_Attribute    GROUP(Credential_AttributeA) END
Credential_AttributeRef &Credential_AttributeA

Results               GROUP,PRE()
lpCredential            LONG
returnValue             LONG
LastWrittenDec          DECIMAL(31)
LastWrittenDate         LONG
LastWrittenTime         LONG
szCredTargetName        &CSTRING
szComment               &CSTRING
CredentialBlob          &STRING
szTargetAlias           &CSTRING
szUserName              &CSTRING
szAttrKeyword           &CSTRING
byAttrValue             &STRING
                      END
  CODE
  szTargetName       = 'XboxLive'
  dwType             = WindowsCredential_TYPE_GENERIC
 !LOOP dwType        = 1 TO 8
  CLEAR(Results)
  CLEAR(Credential_Attribute)
  dwFlags           = 0
  lpCredential      = 0
  returnValue       = CredReadA(szTargetName,dwType,dwFlags,lpCredential)
  IF lpCredential
    Credential       &= lpCredential                     +0
    i64toDecimal(LastWrittenDec,Credential.LastWritten)
    LastWrittenDec   /= 100000 !tenths of microsenconds to hundredths of seconds
    LastWrittenTime   =  LastWrittenDec % (24*60*60*100)
    LastWrittenDate   = (LastWrittenDec - LastWrittenTime) / (24*60*60*100) - 73044 !1800/12/28-1601/01/01
    !or use FileTime to SystemTime and LocalTime 
    szCredTargetName &= Credential.lpszTargetName        +0
    szComment        &= Credential.lpszComment           +0
    CredentialBlob   &= Credential.pCredentialBlob & ':' & Credential.CredentialBlobSize
    IF Credential.pAttributes
      Credential_AttributeRef &= Credential.pAttributes  +0
      Credential_Attribute     = Credential_AttributeRef
    END
    szAttrKeyword    &= Credential_Attribute.lpszKeyword +0
    byAttrValue      &= Credential_Attribute.lpbyValue & ':' & Credential_Attribute.ValueSize
    szTargetAlias    &= Credential.lpszTargetAlias       +0
    szUserName       &= Credential.lpszUserName          +0
    MESSAGE( |
      'IN:lpszTargetName   = ' & ADDRESS(szTargetName) & ':' & szTargetName & |
     '|IN:dwType           = ' & dwType                        & |
     '|IN:dwFlags          = ' & dwFlags                       & |
     '|returnValue         = ' & returnValue                   & |
     '|OUT:lpCredential    = ' & lpCredential & '..'           & |
     '| Flags              = ' & Credential.Flags              & |
     '| Type               = ' & Credential.Type               & |
     '| lpszTargetName     = ' & Credential.lpszTargetName & ':' & szCredTargetName & |
     '| lpszComment        = ' & Credential.lpszComment    & ':' & szComment        & |
     '| LastWrittenHi      = ' & Credential.LastWritten.Hi & '<9>=\/' & LastWrittenDate &'='& FORMAT(LastWrittenDate,@D17) & |
     '| LastWrittenLo      = ' & Credential.LastWritten.Lo & '<9>=/\' & LastWrittenTime &'='& FORMAT(LastWrittenTime,@T4) & |
     '| LastWrittenDec     = ' & LEFT(FORMAT(LastWrittenDec,@N_31)) &| ! '=' & FORMAT(LastWrittenDate,@D17) & FORMAT(LastWrittenTime,@T4) & |
     '| CredentialBlobSize = ' & Credential.CredentialBlobSize & |
     '| pCredentialBlob    = ' & Credential.pCredentialBlob  & ':' & RemoveNull(CredentialBlob) & |
     '| Persist            = ' & Credential.Persist            & |
     '| AttributeCount     = ' & Credential.AttributeCount     & |
     '| pAttributes        = ' & Credential.pAttributes & '..' & |
     '|  lpszKeyword       = ' & Credential_Attribute.lpszKeyword & ':' & szAttrKeyword & |
     '|  Flags             = ' & Credential_Attribute.Flags    & |
     '|  ValueSize         = ' & Credential_Attribute.ValueSize& |
     '|  lpbyValue         = ' & Credential_Attribute.lpbyValue & ':' & RemoveNull(byAttrValue) & |
     '| lpszTargetAlias    = ' & Credential.lpszTargetAlias & ':' & szTargetAlias & |
     '| lpszUserName       = ' & Credential.lpszUserName    & ':' & szUserName    & |
     '','CredReadA',,,,MSGMODE:CANCOPY+MSGMODE:FIXEDFONT)
  
     CredFree(lpCredential)
   ELSE
    MESSAGE( |
      'IN:lpszTargetName   = ' & ADDRESS(szTargetName) & ':' & szTargetName & |
     '|IN:dwType           = ' & dwType                        & |
     '|IN:dwFlags          = ' & dwFlags                       & |
     '|returnValue         = ' & returnValue                   & |
     '|OUT:lpCredential    = ' & lpCredential                  & |
     '|GetLastError        = ' & GetLastError()                & |
     '','CredReadA',,,,MSGMODE:CANCOPY+MSGMODE:FIXEDFONT)
  END
 !END
 
RemoveNull PROCEDURE(String inString)!,String
idx       LONG
  CODE
  LOOP idx = 1 to SIZE(inString)
    IF inString[idx] = '<0>'
       inString[idx] = '.'
    END
  END
  RETURN inString